%TP 4 Exo 2

% Exercise 7

% Define the function and its derivative;
f = @ ( x )( ( x.^2 .* cos ( x ).^3 + sin ( x ).^3))./( exp (x) );
df = @ ( x )((2.*x - x.^2).*cos(x).^3 - 3.*x.^2.*sin(x).*cos(x).^2 + 3.*sin(x).^2 .* cos(x) - sin(x).^3)./ exp (x) ;
% f = @ ( x )( exp ( x )./( cos ( x ).^3 + sin ( x ).^3));
% df = @ ( x )( exp ( x )./( cos ( x ).^3 + sin ( x ).^3) - ...
% 3* exp ( x ).*( sin ( x ).^2.* cos ( x ) - cos ( x ).^2.* sin ( x )) ./ ...
% (( cos ( x ).^3 + sin ( x ).^3).^2) );
% Define the point x0;
x = pi / 4;
% Evaluate the derivative at x0;
df_x = df ( x );

% Create a grid for the interval [10^-16,10^-1];
hs = logspace ( -16 , -1 ,100);

err_r=zeros(size(hs));
err_c=zeros(size(hs));
% Compute the errors corresponding to "Delta_R" and "Delta_C";
for i = 1 : length ( hs )
    h = hs ( i );
    err_r ( i ) = abs ( df_x - ( f ( x + h ) - f ( x ))/ h );
    err_c ( i ) = abs ( df_x - imag ( f ( x +1j * h ))/ h );
end

% Plot;
figure;
hold on;
set(gca,'xscale','log');
set(gca,'yscale','log');
pr = plot ( hs , err_r , ' ro ');
pc = plot ( hs , err_c , ' bo ');
hs_ref=[1e-9 5e0];
pr_ref = plot ( hs_ref , hs_ref , ' -m ','LineWidth',2.0);
pc_ref = plot ( hs_ref , hs_ref.^2 , ' -c ','LineWidth',2.0);
grid on
legend([pr,pr_ref,pc,pc_ref],'real step','h','complex step','h^2','Location','southeast')
xlabel('Pas h')
ylabel('Erreur en \pi/4')
title('Approximation de la dérivée de la fonction (x^2 cos^3 x + sin^3 x)/(e^x)')